#!/bin/bash

#REsieve-run.sh runs the REsieve-master.sh script iteratively over a list of *.phy alignments, and when finished, summarizes the data in a table using the tablify.sh script.

#It needs a raw text file with a list of the *.phy alignments to be analyzed, that looks like this (remember to ingore the "#" symbols)
#alignment1.phy
#alignment2.phy
#alignment3.phy
#etc...

#also, you must give the file names for the input files that REsieve-master.sh needs (view README). (1) the "clade,species" csv file, (2) the control file for paml's branch optimization, (3) the control file for paml's LRT test, and (4) a backbone tree with a single polytomy on the questioned relationship, on simple nex format (view README).

# Usage:
# %s <alingments_table> <clade,speices_file> <control_file_branchopt> <control_file_LRT> <backbone_tree.simplenex>

p_val_threshold=0.05 #### USER DEFINED ####
pval_name=$(echo $p_val_threshold | cut -d "." -f2)

ali_table=$1
clspp_file=$2
bropts_ctl=$3
lrt_ctl=$4
bbone_simpnex=$5

working_dir=$(pwd)
resieve_aa_mast_path=/home/flugcanje/Desktop/Dktp/Developing/DEV_resieve/AAcids/scripts/REsieve-aa-master.sh
tablify_path=/home/flugcanje/Desktop/Dktp/Developing/DEV_resieve/AAcids/scripts/tablify.sh



for ali in $(cat $ali_table);
do
 genename=$(echo $ali | sed 's/.phy//g')
 $resieve_aa_mast_path $genename $ali $clspp_file $bropts_ctl $lrt_ctl $bbone_simpnex
done



for case in $(cat $ali_table | sed 's/.phy//g')
do
  cd "$case"/
  $tablify_path $p_val_threshold "$working_dir"/Trims_at_p"$pval_name".csv "$working_dir"/"$clspp_file"
  cd $working_dir
done


