#!/bin/bash

#Produced under a Sharing is caring license by MasterSquare. Use it and modify it and incorporate it to your scripts. If you acknowledge me, even better.

#fastophy: a simple script in bash to convert *alignments* (so far tested with aligned data - i.e. data in which all sequences have equal length) from FASTA to PHYLIP format. Uses no "funky" linux commands. Written and tested on Ubuntu 13.04. As of today (2/2/2014), not yet tested on Mac, but it might work. Just check if all the commands are installed, and it should work just fine. It should NOT work on a normal Windows.
#A word of caution: this script has NO error messages incorporated (save from those in the commands included)

#Usage:
#%s inputfile(fas) outputfile(phy)

infile=$1
outfile=$2

#COUNTS THE AMOUNT OF SPECIES
sppno=$(grep ">" $infile | wc -l)
echo ">" >> $infile

#EXTRACTS THE SEQUENCES ON THE SAME ORDER THEY ARE ON THE ORIGINAL INFILE, AND PUTS THEM EACH ON A SINGLE LINE ON A FILE CALLED SEQUENCES.TMP. ALREADY THERE, THEY ARE MODIFIED BY PUTTING A SPACE ON EACH SEQUENCE EVERY 10 CHARACTERS. note that a ">" is added at the end of the infile so the sed between ">sequence" and the next ">" works for the last sequence.
for i in $(grep ">" $infile | head -n-1 )
do seqame=$(echo $i | sed 's/>//g')
 sed -n "/^$i$/,/^>/p" $infile  | head -n-1 | tail -n+2 | tr -d [:space:] | awk '{gsub(/........../,"& ",$1); print$1}' >> sequences.tmp
done

#DETERMINES THE LENGTH OF THE SEQUENCES BY COUNTING THE BYTES ON THE FIRST LINE AND SUBSTRACTING 1 (THE END-OF-LINE CHARACTER). also the ">" at the end of the infile is removed.
seqlength=$(echo $(head -n1 sequences.tmp | tr -d " " | wc -c)-1 | bc)
echo $sppno $seqlength > $outfile
sed -i 's/>$//g;/^$/d' $infile

#COUNTS THE NUMBER OF FIELDS (EACH 10-CHARACTER CHARACTER BLOCK), AND UNTIL THAT NUMBER IS REACHED, IT TAKES CONSECUTIVE GROUPS OF 6 FIELDS AND PASTES THEM ONE BELOW THE OTHER, THEN IT PUTS AN INDENTATION OF 12 SPACES (10 FOR THE SEQUENCE NAME, AND 2 OF SPACE BETWEEN NAME AND SEQUENCE)
fields=$(awk '{print NF}' < sequences.tmp  | head -n1)
beg=1
end=6
while [ "$beg" -le "$fields" ]
do
 cut -d" " -f"$beg"-"$end" sequences.tmp >> presque.tmp
 echo  >> presque.tmp; beg=$(echo $beg+6 | bc); end=$(echo $end+6 | bc); done; sed -i 's/^/            /' presque.tmp

#INPUTS THE SEQUENCE NAMES ON THE SAME ORDER THEY WERE ON THE INFILE. THEY ARE EDITED A LITTLE SO THAT IT IS ENSURED THAT THEY ARE NO LARGER THAN 10 CHARACTERS, AND THAT THE FIRST SEQUENCE BLOCK IS VISUALLY ALIGNED.
for i in $(grep ">" $infile | sed 's/>//g'| sed 's/$/          /' | cut -c1-10 | tr " " ":")
do
 sed -i "0,/^          /{s/^          /$i/}" presque.tmp
done
cat -s presque.tmp | sed 's/:/ /g' >> $outfile

rm sequences.tmp presque.tmp
