#!/bin/bash

# Usage:
# paml_blength_optimizer <$prefix> <polytomous_tree.nwk> <controlfile.ctl>

prefix=$1
unopttree=$2
ctlfile=$3

seqline=$(sed -n 1p $ctlfile | cut -d "*" -f1)
treeline=$(sed -n 2p $ctlfile | cut -d "*" -f1)
outfi=$(sed -n 4p $ctlfile | cut -d "*" -f1)

 echo $seqline
 echo $treeline
 echo $outfi

newseq="	seqfile = $prefix.phy "
 
newtree="	treefile = $unopttree "
newout="	outfile = "$prefix"_branchopt "

 echo $newseq
 echo $newtree
 echo $newout


sed -i "s/$seqline/$newseq/;s/$treeline/$newtree/;s/$outfi/$newout/" $ctlfile

./codeml $ctlfile

sed -n $(echo $(grep -n "tree length = " "$prefix"_branchopt | cut -d":" -f1)+4 | bc)p "$prefix"_branchopt | tr -d [:blank:] > "$prefix"_bestTree.nwk

newicktops -lengths "$prefix"_bestTree.nwk

mkdir "$prefix"_branchopt_paml
mv 2base.t rst rst1 rates rub lnf "$prefix"_branchopt "$prefix"_branchopt_paml
cp $ctlfile "$prefix"_branchopt_paml/"$ctlfile"-copy
