#Likelihood ratio testing

# Usage:
# podatestA poda <ctrlfile(will-default-to-aaml.ctl)> 


sumup_path=/home/flugcanje/Desktop/Dktp/Developing/DEV_resieve/AAcids/scripts/sumup.sh


echo "Remember to have (on the working directory) the following files:

1. 1rate tree file (*podaX_1rate.tree)
2. 2/3 rates tree file (podaX_Yrates.tree)
3. alignment for current poda (*podaX.phy)
4. baseml.ctl"

#echo "
#Ready(y/n)?"
#read nowornever


#if [ "$nowornever" = "n" ]; then
#  echo "OK, goodbye - call me again when you need me"
#  exit
#elif [ "$nowornever" = "y" ]; then
#  echo "Allright.

#"

#fi

if [[ -z "$1" ]]
then
  echo "
Which poda?
"
read poda
else
  poda=$1
fi

if [[ -z "$2" ]]
then
  contfile=aaml.ctl
else
  contfile=$2
fi



 if [ -f *"$poda"_2rates.tree ] && [ ! -f *"$poda"_3rates.tree ]; then
   kind=2
   rateb=2rates
   echo "
 Alternative tree is of 2 rates
 "
 elif [ -f *"$poda"_3rates.tree ] && [ ! -f *"$poda"_2rates.tree ]; then
   kind=3
   rateb=3rates
   echo "
 Alternative tree is of 3 rates
 "
 elif  [ -f *"$poda"_2rates.tree ] && [ -f *"$poda"_3rates.tree ]; then
   echo "Tree files are crazy, I'm seeing one with 2 and another with 3 rates
 
 exiting..."
   exit
# else
#   echo "
# Are there tree files for both 1rate and 2/3rates?
 
# exiting..."
#   exit
 fi
 
 cp $contfile $contfile.t1
 
 seqline=$(head -n1 $contfile.t1 | cut -d "*" -f1)
 treeline=$(head -n2 $contfile.t1 | tail -n1 | cut -d "*" -f1)
 outfi=$(head -n4 $contfile.t1 | tail -n1 | cut -d "*" -f1)
 
 #echo $seqline
 #echo $treeline
 #echo $outfi
 
 
 prefix=$(ls *"$poda".phy | cut -d "." -f1)
 
 newseq="	seqfile = $prefix.phy "
 
 newtreea="	treefile = "$prefix"_1rate.tree "
 newouta="	outfile = "$prefix"_1rate "
 
 newtreeb="	treefile = "$prefix"_$rateb.tree "
 newoutb="	outfile = "$prefix"_$rateb "
 
 #echo $newseq
 #echo $newtreea
 #echo $newouta
 #echo $newtreeb
 #echo $newoutb
 
 ##### STEP 1: ONE RATE @ PAML W/ BASEML
 
 newicktops -boot "$prefix"_1rate.tree
 
 sed "s/$seqline/$newseq/;s/$treeline/$newtreea/;s/$outfi/$newouta /" $contfile.t1 > $contfile
 
 rm $contfile.t1
 
 ./codeml $contfile
 
 mkdir $prefix
 mkdir $prefix/1rate_$poda
 
 mv 2base.t rst rst1 rates rub lnf "$prefix"_1rate $prefix/1rate_$poda
 cp $contfile "$prefix"_1rate $prefix/1rate_$poda/
 
 echo "
 
 First test packed and ready, going for second one...
 
 "
 
 ##### STEP 2: MORE THAN ONE RATE @ PAML W/ BASEML
 
 newicktops -boot "$prefix"_"$rateb".tree
 
 cp $contfile $contfile.t1
 
 seqline=$(head -n1 $contfile.t1 | cut -d "*" -f1)
 treeline=$(head -n2 $contfile.t1 | tail -n1 | cut -d "*" -f1)
 outfi=$(head -n4 $contfile.t1 | tail -n1 | cut -d "*" -f1)
 
 sed "s/$seqline/$newseq/;s/$treeline/$newtreeb/;s/$outfi/$newoutb /" $contfile.t1 > $contfile

 rm $contfile.t1
 
 ./codeml $contfile
 
 mkdir $prefix/"$rateb"_$poda
 
 mv 2base.t rst rst1 rates rub lnf "$prefix"_$rateb $prefix/"$rateb"_$poda
 cp $contfile $prefix/"$rateb"_$poda/
 
 echo "
 
 Both tests packed and ready, summarizing results...
 
 "
 
 mkdir $prefix/input_files
 mv *.ps $prefix*.tree $prefix/input_files
 cp  $prefix.phy $prefix/input_files
 
 cd $prefix

 ##### STEP 3: SUMMARIZING RESULTS W/ SUMUP

#if [[ -z "$2" ]]
#then

  $sumup_path

#elif [[ "$2" == "v" ]]
#then
#  sumup v
#else
#  sumup
#fi

# trimno=$(echo $trimno-1 | bc)
 
# cd ..

#done

#echo "Remember notrim!!!!!"
