#!/bin/bash

# script producetrees.sh -- for a new flavor of the rudy script (rudy-2.sh), now branch length estimates are made by putting the simulated topology (save for the region of interest, which has a polytomy) on PAML, with free branch lengths parameters, and allow it to roll freely, avoiding a tree construction step. with this script also the 1rate and 3rates trees are produced.

#Usage:

# producetrees.sh <prefix> <gene_sppcladesfile.csv> <full_sppcladesfile.csv> <full_backbonetree.NEX> <$trimno>

prefix=$1
genecsv=$2
fullcsv=$3
fullbackbone=$4
trimno=$5
wc_fullcsv=$(wc -l $fullcsv | cut -d" " -f1 | tr -d [:blank:])
wc_genecsv=$(wc -l $genecsv | cut -d" " -f1 | tr -d [:blank:])


trimtrees_path=/home/flugcanje/Desktop/Dktp/Developing/DEV_resieve/AAcids/scripts/trimtrees.R
labeltrees_path=/home/flugcanje/Desktop/Dktp/Developing/DEV_resieve/AAcids/scripts/labeltrees.R


if [[ "$wc_fullcsv" == "$wc_genecsv" ]]
then
  cp $fullbackbone "$prefix"_backbone.nex
  sed -n 3p $fullbackbone | cut -d"=" -f2 > "$prefix"_backbone.tree
else
  cat $genecsv | cut -d"," -f2 > "$prefix"_pool.txt
  cat $fullcsv | cut -d"," -f2 >> "$prefix"_pool.txt

  cat "$prefix"_pool.txt | sort | uniq -u > "$prefix"_absents.txt

  echo "

trimtreees

"
  Rscript $trimtrees_path "$prefix"_absents.txt $fullbackbone "$prefix"_backbone.tree
rm "$prefix"_pool.txt "$prefix"_absents.txt


echo "BEGIN TREES;
tree '$prefix'_backbone=$(cat "$prefix"_backbone.tree)
end;" > "$prefix"_backbone.nex

fi


grep -w Clade1 $genecsv | cut -d"," -f2 > "$prefix"_clade1.tmp
grep -w Clade2 $genecsv | cut -d"," -f2 > "$prefix"_clade2.tmp
grep -w Clade3 $genecsv | cut -d"," -f2 > "$prefix"_clade3.tmp

echo "

labeltrees

"


Rscript $labeltrees_path "$prefix"_backbone.nex "$prefix"_labeled.nwk "$prefix"_clade1.tmp "$prefix"_clade2.tmp "$prefix"_clade3.tmp

rm "$prefix"_clade*.tmp "$prefix"_backbone.nex

cp "$prefix"_labeled.nwk "$prefix"_1rate.tree
cp "$prefix"_labeled.nwk "$prefix"_3rates.tree

if [[ $(grep Clade1 $genecsv | wc -l) != "1" ]]
then
  clad1=$(grep -w Clade1 nodes.txt | egrep -w -o N_[0-9]*)
  sed -i "s/$clad1)/\$1)/g;s/$clad1,/\$1,/g" "$prefix"_1rate.tree
  sed -i "s/$clad1)/\$1)/g;s/$clad1,/\$1,/g" "$prefix"_3rates.tree
else
  loner1=$(grep -w Clade1 $genecsv | cut -d"," -f2)
  sed -i "s/$loner1/$loner1\$1/g" "$prefix"_1rate.tree
  sed -i "s/$loner1/$loner1\$1/g" "$prefix"_3rates.tree
fi

if [[ $(grep Clade2 $genecsv | wc -l) != "1" ]]
then
  clad2=$(grep -w Clade2 nodes.txt | egrep -w -o N_[0-9]*)
  sed -i "s/$clad2)/\$1)/g;s/$clad2,/\$1,/g" "$prefix"_1rate.tree
  sed -i "s/$clad2)/\$2)/g;s/$clad2,/\$2,/g" "$prefix"_3rates.tree
else
  loner2=$(grep -w Clade2 $genecsv | cut -d"," -f2)
  sed -i "s/$loner2/$loner2\$1/g" "$prefix"_1rate.tree
  sed -i "s/$loner2/$loner2\$2/g" "$prefix"_3rates.tree
fi

if [[ $(grep Clade3 $genecsv | wc -l) != "1" ]]
then
  clad3=$(grep -w Clade3 nodes.txt | egrep -w -o N_[0-9]*)
  sed -i "s/$clad3)/\$1)/g;s/$clad3,/\$1,/g" "$prefix"_1rate.tree
  sed -i "s/$clad3)/\$3)/g;s/$clad3,/\$3,/g" "$prefix"_3rates.tree
else
  loner3=$(grep -w Clade3 $genecsv | cut -d"," -f2)
  sed -i "s/$loner3/$loner3\$1/g" "$prefix"_1rate.tree
  sed -i "s/$loner3/$loner3\$3/g" "$prefix"_3rates.tree
fi

sed -i "s/N_[0-9]*//g" "$prefix"_1rate.tree "$prefix"_3rates.tree

#clad2=$(grep Clade2 nodes.txt | egrep -w -o N_[0-9]*)
#clad3=$(grep Clade3 nodes.txt | egrep -w -o N_[0-9]*)

#sed "s/$clad1)/\$1)/g;s/$clad2)/\$1)/g;s/$clad3)/\$1)/;s/$clad1,/\$1,/g;s/$clad2,/\$1,/g;s/$clad3,/\$1,/;s/N_[0-9]*//g" "$prefix"_labeled.nwk > "$prefix"_1rate.tree

#sed "s/$clad1)/\$1)/g;s/$clad2)/\$2)/g;s/$clad3)/\$3)/;s/$clad1,/\$1,/g;s/$clad2,/\$2,/g;s/$clad3,/\$3,/;s/N_[0-9]*//g" "$prefix"_labeled.nwk > "$prefix"_3rates.tree


rm nodes.txt "$prefix"_labeled.nwk
