#Sums up the results from the podatests (likelihood-ratio tests)

# Use:
# sumup <v> <-- if "v" is on the first argument, it will open the output file

mainname=$(pwd | rev | cut -d "/" -f1 | rev)


if [ -d 2rates* ]; then
  kind=a
  echo "
1rate/2rates
"
elif [ -d 3rates* ]; then
  kind=b
  echo "
1rate/3rates
"
else
  echo "could not determine amount of subdivisions"
  exit
fi



echo "Info for the file $mainname

" > Summary_$mainname.txt


#fetch the lnL on the paml output file of the one-rate test
lnlstring1rate=$(cat 1rate*/*1rate* | grep lnL | cut -d ':' -f4)

lnlstring1rate2=$(echo $lnlstring1rate | cut -d " " -f1)

#fetch the relative branch rates on the same file
rbranch1=$(cat 1rate*/*1rate* | grep branches: | cut -d ':' -f2 | tr -s [:blank:])




#depending on the qty of subtrees, fetch the lnL and the branch length rates
if [ "$kind" = "a" ]; then
  lnlstring2rates=$(cat 2rates*/*2rates* | grep lnL | cut -d ':' -f4)
  lnlstring2rates2=$(echo $lnlstring2rates | cut -d " " -f1)

  rbranch2=$(cat 2rates*/*2rates* | grep branches: | cut -d ':' -f2)

  echo "rates for branches on subtrees: 
	1 clock : $rbranch1
	2 clocks: $rbranch2" >> Summary_$mainname.txt
  
  echo "

lnL 1 rate= $lnlstring1rate2" >> Summary_$mainname.txt
  echo "lnL 2 rates= $lnlstring2rates2" >> Summary_$mainname.txt

  dif=$(echo $lnlstring2rates2 - $lnlstring1rate2 | bc)
  multdif=$(echo $dif*2 | bc)

elif [ "$kind" = "b" ]; then
  lnlstring3rates=$(cat 3rates*/*3rates* | grep lnL | cut -d ':' -f4)

  lnlstring3rates2=$(echo $lnlstring3rates | cut -d " " -f1)

  rbranch3=$(cat 3rates*/*3rates* | grep branches: | cut -d ':' -f2 | tr -s [:blank:])
  
  echo "rates for branches on subtrees: 
	1 clock: $rbranch1
	3 clocks: $rbranch3" >> Summary_$mainname.txt
  
  echo "

lnL 1 rate= $lnlstring1rate2" >> Summary_$mainname.txt
  echo "lnL 3 rates= $lnlstring3rates2" >> Summary_$mainname.txt

  dif=$(echo $lnlstring3rates2 - $lnlstring1rate2 | bc)
  multdif=$(echo $dif*2 | bc)

fi
pval=$(echo "pchisq(abs("$multdif"),df=2,lower.tail=FALSE)" | R --no-save | tail -n -2 | head -n -1 | cut -d"]" -f2 | tr -d [:blank:])
echo "

difference= $dif
difference*2= $multdif


chi-square p-value (df=2)= $pval" >> Summary_$mainname.txt

if [[ -z "$1" ]]
then
  echo "Silent mode...I'm not showing you the final summary file"
elif [[ "$1" == "v" ]]
then
  echo "Opening output file Summary_$mainname.txt ..."
  gedit Summary_$mainname.txt &
else
  echo "You specified an unaccepted argument...so I just won't show you the final file"
fi
