#!/bin/R
#Usage:
#  Rscript trimsgraphs.R genecladeratesfile
#a pdf called Rplots.pdf will contain the graphs

#data import
argus = commandArgs(trailingOnly=TRUE)
x <- read.csv(file=argus[1],header=TRUE)

#plotting the absolute relative rates
plot(x$Clade1,type="b",lwd=2,xaxt="n",ylim=c(0,4),col="yellow",xlab="Trimming Step",ylab="Clade relative rate",main="Absolute relative rates through trims")
axis(1,at=1:length(x$Trim),labels=x$Trim)
lines(x$Clade2,col="red",type="b",lwd=2)
lines(x$Clade3,col="blue",type="b",lwd=2)
legend("topright",legend=c("Clade1","Clade2","Clade3"),lty=1,lwd=2,pch=21,col=c("yellow","red","blue"),ncol=1,bty="n",cex=0.8,text.col=c("yellow","red","blue"),inset=0.01)

#plotting the percentage relative rates
plot(x$C1P,type="b",lwd=2,xaxt="n",ylim=c(0,360),col="yellow",xlab="Trimming Step",ylab="Clade relative rate",main="Percentage of relative rates through trims")
axis(1,at=1:length(x$Trim),labels=x$Trim)
lines(x$C2P,col="red",type="b",lwd=2)
lines(x$C3P,col="blue",type="b",lwd=2)
legend("topright",legend=c("Clade1","Clade2","Clade3"),lty=1,lwd=2,pch=21,col=c("yellow","red","blue"),ncol=1,bty="n",cex=0.8,text.col=c("yellow","red","blue"),inset=0.01)

#plotting the chi-square values
plot(x$pval,type="b",lwd=2,xaxt="n",ylim=c(0,0.6),col="green",xlab="Trim Step",ylab="Chi-square p-value",main="Chi-square p-value trough trims")
abline(h=0.05,col="red")
axis(1,at=1:length(x$Trim),labels=x$Trim)
legend("topright",legend=c("Chi-square","P=0.05"),lty=1,lwd=2,col=c("green","red"),ncol=1,bty="n",cex=0.8,text.col=c("green","red"),inset=0.01)
