#!/bin/bash

#Produced under a Sharing is caring license by MasterSquare. Use it and modify it and incorporate it to your scripts. If you acknowledge me, even better.

#phytofas: a simple script in bash to convert *alignments* (so far tested with aligned data - i.e. data in which all sequences have equal length) from PHYLIP to FASTA format. Uses almost no "funky" linux commands save for 'paste' and 'fold'. Written and tested on Ubuntu 13.04. As of today (2/2/2014), not yet tested on Mac, but it would probably not work because they don't like proper LINUX commands so much. But if they're all installed, it should work just fine. It should NOT work on a normal Windows.
#A word of caution: this script has NO error messages incorporated (save from those in the commands included)

#Usage:
#%s inputfile(phy) outputfile(fas)

infile=$1
outfile=$2

#PRODUCES A FILE WITH ONLY SEQUENCES (SPPNAMES AND .PHY HEADER REMOVED), AND SUBSTITUTES EMPTY LINES WITH A COLON (THESE WILL BE THE DELIMITERS BETWEEN SQUENCE BLOCKS, WHEN IT'S TIME TO GRAB THEM). ALSO PRODUCES A FILE IN WHICH THE LINE # OF EACH COLON IS PRINTED (I.E. THE BOUNDARIES OF EACH SEQUENCE BLOCK)
tail -n+2 $infile | cut -d" " -f2- | sed 's/^ *//g' | cat -s | sed 's/^$/:/g' > temporal.tmp
echo ":" >> temporal.tmp
sed -i '1s/^/:\n/' temporal.tmp
grep -n ":" temporal.tmp | cut -d":" -f1 > boundaries.tmp


#EXTRACTS THE CURRENT SEQUENCE BLOCK, PUTS IT ON A TEMPORARY FILE CALLED CURSEQ.TMP, AND ADDS IT AS A NEW COLUMN TO THE EVER-GROWING FINAL FILE USING THE PASTE COMMAND. THEN REMOVES THE WHITESPACES WITH SED (THIS STEP COULD BE SKIPPED IF AN EMPTY STRING IS USED AS DELIMITER ON THE PASTE COMMAND)
touch $outfile
for i in $(cat boundaries.tmp  )
do pair=$(grep -A1 ^$i$ boundaries.tmp)
 start=$(echo $(echo $pair | cut -d" " -f1)+1 | bc)
 end=$(echo $(echo $pair | cut -d" " -f2)-1 | bc)
 max=$(tail -n1 boundaries.tmp)
 if [ "$start" -ge "$max" ]
 then
  break
 fi
 sed -n ""$start","$end"p" temporal.tmp | sed 's/ //g' > curseq.tmp
 cp $outfile final.tmp2
 paste final.tmp2 curseq.tmp > $outfile 
done
sed -i -e 's/[ \t]*//g' $outfile

#TAKES THE TAXA LIST FROM THE INFILE, AND ADDS THE TAXA NAME ON EVERY OTHER LINE OF THE FILE WITH THE SEQUENCES
line=1
cp $outfile testbed.tmp
for i in $(tail -n+2 $infile | cut -d" " -f1 | sed '/^$/d')
do fastaname=$(echo -e ">"$i"")
 sed -i ""$line"i"$fastaname"" testbed.tmp
 line=$(echo $line+2 | bc)
done

#WRAPS THE TEXT AT 60 CHARACTERS (NOT STRICTLY NECESSARY, MOST IF NOT ALL PHYLOGENETIC AND SEQUENCE READING SOFTWARE WOULD UNDERSTAND EVEN WITH THE WRAPPING
fold -w60 testbed.tmp > $outfile

rm final.tmp2 curseq.tmp testbed.tmp boundaries.tmp temporal.tmp
