# R script that trims trees according to a list passed from lapodadora.sh

# Use:
# Rscript /bin/trimtrees.R <Alltocut_list.csv> <fullbackbone.NEX> <$prefix_backbone.tree>

library(adephylo)
library(ape)

arg = commandArgs(trailingOnly=TRUE)
tocut <- as.matrix(read.csv(file=arg[1],header=FALSE))

t1 <- ladderize(read.nexus(file=arg[2]),right=TRUE)
t11 <- ladderize(drop.tip(t1,tocut[,"V1"],trim.internal=TRUE),right=TRUE)
write.tree(t11,file=arg[3])
